#include <iostream>

class Animal
{
 public:
  virtual void eat()
  {
    std::cout << "Tier isst" << std::endl;
  }
};

class Cat : public Animal
{
 public:
  void eat() override
  {
    std::cout << "Katze isst eine Maus" << std::endl;
  }
};

class Mouse : public Animal
{
 public:
  void eat() override
  {
    std::cout << "Maus isst K\204se" << std::endl;
  }
};

class Worm : public Animal
{
};

void feed(Animal& animal)
{
  animal.eat();
}

void feedNoReference(Animal animal)
{
  animal.eat();
}

int main()
{
  Cat cat;
  Mouse mouse;
  feed(cat);
  feed(mouse);
  std::cout << "---------------" << std::endl;
  feedNoReference(cat);
  feedNoReference(mouse);
  return 0;
}
